module compound.

%  Some convenient compound tactics are defined and named below.

import ndtac tacticals.

%  This tactic will assume the succedent of an implication, and then
%  break all conjunctions and instantiate (just once) all the
%  universal quantifiers in the hypotheses.

simple_tac InGoal OutGoal :-
  then imp_i_tac (repeattac (orelse (and_e_tac 0) (forall_e_tac 0)))
       InGoal OutGoal.

%  This tactic will break up the conjunctions in a goal and then try
%  to immediately close all the new subproofs.

finish_tac InGoal OutGoal :-
  repeattac (orelse and_i_tac close_tac) InGoal OutGoal.
