% This module contains several examples of functional programs that are
% defined using patterns. This module is loaded automatically when 
% remove_pat is. The examples can then be used to demonstrate the transformers
% by invoking goals such as
%
%      ?- append_prog Prog, trans_bin Prog Fp.


module		example_pat.

import	constants.

type	append_prog	((list val) -> (list val) -> (list val)) -> o.
type	cappend_prog	((pair (list val) (list val)) -> (list val)) -> o.

type	member_prog	(val -> (list val) -> bool) -> o.
type	cmember_prog	((pair val (list val)) -> bool) -> o.

type	map_prog	((val -> val) -> (list val) -> (list val)) -> o.
type	cmap_prog	((pair (val -> val) (list val)) -> (list val)) 
									-> o.
type	domain_prog	((list (pair val val)) -> (list val)) -> o.


append_prog  (fixpt (Append\ (usepat
   [(local L\ ((Append nil L) --> L)),
    (local X\ (local L\ (local K\ ((Append (cons X L) K) -->
                                           (cons X (Append L K))))))]))).

cappend_prog  (fixpt (Append\ (usepat
    [(local L\ ((Append (pair nil L)) --> L)),
     (local X\ (local L\ (local K\ ((Append (pair (cons X L) K)) -->
                                            (cons X (Append (pair L K)))))))]))).

member_prog (fixpt (Member\ (usepat
    [(local X\ ((Member X nil) --> false)),
     (local X\ (local Y\ (local L\ ((Member X (cons Y L)) -->
		                      (cond (equal X Y) truth (Member X L))))))]))).

cmember_prog (fixpt (Member\ (usepat
    [(local X\ ((Member (pair X nil)) --> false)),
     (local X\ (local Y\ (local L\ 
        ((Member (pair X (cons Y L))) -->
	    (cond (equal X Y) truth (Member (pair X L)))))))]))).

map_prog  (fixpt (Map\ (usepat
     [(local F\ ((Map F nil) --> nil)),
      (local F\ (local X\ (local L\ ((Map F (cons X L)) -->
                                            (cons (F X) (Map F L))))))]))).

cmap_prog  (fixpt (Map\ (usepat
     [(local F\ ((Map (pair F nil)) --> nil)),
      (local F\ (local X\ (local L\ 
          ((Map (pair F (cons X L))) -->
                          (cons (F X) (Map (pair F L)))))))]))).

domain_prog (fixpt (Domain\ (usepat
    [((Domain nil) --> nil),
     (local X\ (local Y\ (local L\ ((Domain (cons (pair X Y) L)) -->
                                                (cons X (Domain L))))))]))).

