% This module contains example programs that might be used to illustrate 
% the tail-recursion transformation implemented by rem_tailrec and described
% in the San Francisco Symposium on Logic Programming.

module		example_tr.


import	constants.

kind	name	type.

type	prog	name -> A -> o.


% Some tail recursive programs.
prog gcd1 (fixpt Gcd\X\Y\ (cond (1 == X) 1 
                                (cond (X == Y) X
                                      (cond (X < Y) (Gcd Y X)
                                            (Gcd (X - Y) Y))))).

prog gcd2 (fixpt Gcd\X\Y\ (cond (1 == X) 1 
                                (cond (X < Y) (Gcd Y X)
                                      (cond (X == Y) X
                                            (Gcd (X - Y) Y))))).
  
prog fact (fixpt Fact\N\M\ (cond (0 == N) M (Fact (N - 1) (N * M)))).

prog sum (fixpt Sum\N\M\ (cond (0 == N) M (Sum (N - 1) (M + 1)))).

prog rev (fixpt Reverse\X\Y\ (cond (null X) Y
                             (Reverse (cdr X) (cons (car X) Y)))).
