% Checks whether a type contains the absurd type (dd Theta\Theta).
% This code is a little strange, because LambdaProlog
% variables may occur in the type.

module tp_absurd.

import tp_ml tp_simple tp_types.

type  contains_absurd  tp -> o.
type  absurd           tp -> o.
type  unique_constant  tp.
type  unique_tpfun     tp -> tp.

contains_absurd unique_constant :- !, fail.
contains_absurd (Alpha ==> Beta) :- !, 
  (contains_absurd Alpha; contains_absurd Beta).
contains_absurd (dd unique_tpfun) :- !, fail.
contains_absurd (dd Theta\Theta) :- !.
contains_absurd (dd Alpha) :- !,
  (pi Theta\ contains_absurd (Alpha Theta)).

absurd unique_constant :- !, fail.	    % variables are not absurd.
absurd (dd unique_tpfun) :- !, fail.        % neither are quantified variables.
absurd (dd Theta\ Theta).
