% This is the type inference for an ML-like
% core language with a 'let' that is generically typed.
% It extends the 'termtype_e' and 'vartype_e' predicates from tp_simple_2.6.

module tp_ml.

import tp_types.

type  tlet  (term -> term) -> term -> term.   % generically typed let.

type  gv    term -> term -> vtpair.

termtype_e (tlet U0 V0) (tlet U1 V1) Alpha E :- !,
  termtype_e V0 V1 ArgType E,
  (pi X\ (termtype_e (U0 X) (U1 X) Alpha [(gv X V0) | E])).

% E works in the recursive call to termtype_e, since V0
% was in the environment E when first encountered.
vartype_e X Alpha [(gv X V0) | E] :- !, termtype_e V0 V1 Alpha E.
