% Type inference for a simply typed language, based
% on the simply typed lambda calculus (tp_simple).
% types are prefixed by 'y', terms by 't' to prevent any possible
% conflict with built-in types and names.

module tp_scon.

import tp_types tp_simple.

type  ynum	tp.			       % numbers.
type  #		int -> term.

type  ybool	tp.			       % booleans.
type  ttrue	term.			       % true.
type  tfalse	term.			       % false.

type  yprod	tp -> tp -> tp.		       % product type constructor.
type  tpair	term.
type  tfst	term.
type  tsnd	term.

type  contype   term -> tp -> o.	% exported.

contype  (# N)  ynum.

contype  ttrue  ybool.
contype  tfalse ybool.

contype  tpair  (Alpha ==> Beta ==> yprod Alpha Beta).
contype  tfst   (yprod Alpha Beta ==> Alpha).
contype  tsnd   (yprod Alpha Beta ==> Beta).
