%  File:  describe.pl

%  This file contains the text for the special_goal describe.


describe_text(help,[
'help : o		help.',
'	Print the help message summary of commands.'
]).

describe_text(describe,[
'describe : A -> o	describe <special_predicate>.',
'	Briefly describe <special_predicate>.'
]).

describe_text(not,[
'not : o -> o		not <goal>.',
'	This is the negation-by-failure operation.  The same as in',
'	C-Prolog.'
]).

describe_text(true,[
'true : o		true.',
'	The alway true goal.'
]).

describe_text(fail,[
'fail : o		fail.',
'	The goal which never succeeds.'
]).

describe_text(=,[
'= : A -> A -> o		<term> = <term>',
'	Unifies its two arguments.'
]).

describe_text(is,[
'is : A -> A -> o		<term> is <fp-expression>',
'	This calls the functional interpreter from within LP.  It',
'	takes the functional program in the second argument, evaluates',
'	it, then unifies the result with <term>.'
]).

describe_text(iss,[
'iss : (A -> o) -> (A -> o) -> o		<term> is <monadic-predicate>',
'	(Super is)  This one is fun.  It is the lp version of the',
'	bag-of construction.  Instead of returning a simple list as',
'	the result, it returns the bag data-structure.'
]).

describe_text(fp,[
'fp : o			fp.',
'	Call the functional program interpreter.  Return to lp by the',
'	fp command lp.'
]).

describe_text(save,[
'save : o		save.',
'	Save the current C-Prolog image into the file "lp.save".'
]).

describe_text(paths,[
'paths: A -> o          paths <File> [''<File>''].',
'	Loads a Prolog file that contains a list of assertions of the form',
'			path_name(<Path>).',
'	and uses these to initialise the set of places where modules are',
'	looked for. The predicates add_path and remove_path can be used',
'	to modify this list. Note that the name of the Prolog file should',
'	be enclosed in quotes if it contains special symbols.'
]).

describe_text(add_path,[
'add_path: A -> o	add_path <Path> [''Path''].',
'	Adds a path to those already known as an additional place', 
'	to look for modules. Quotes are useful if pathname has',
'	special symbols in it.'
]).

describe_text(remove_path,[
'remove_path: A -> o	remove_path <Path> [''Path''].',
'	Removes a pathname. Quotes are necessary if',
'	pathname contains special symbols.'
]).

describe_text(show_paths,[
'show_paths: o		show_paths.',
'	Displays a list of directories that are currently',
'	searched for modules.'
]).

describe_text(use,[
'use : A -> o		use <module>.',
'	Imports the module into the current environment.  This is done',
'	by adding this module to the import list of the module main.',
'	To see the current list of imported modules, do a',
'	"write_module main".   If the module is not already loaded, it',
'	will be loaded automatically.'
]).

describe_text(unuse,[
'unuse : A -> o		unuse <module>.',
'	Removes the module from the current import list of main.'
]).

describe_text(load,[
'load : A -> o		load <module>.',
'	Load the module.  The module is, however, not yet imported.',
'	Use the "use" command to do that.'
]).

describe_text(reload,[
'reload : A -> o		reload <module>.',
'	Reinitializes the module by reading in a new version.  This is',
'	useful when you have edited the module and wish to update the ',
'	systems version.  reload does not affect the modules import',
'	status. '
]).

describe_text(unload,[
'unload : A -> o		unload <module>.',
'	Zeros out the module.  The system tries its best to forget the',
'	module was ever read.'
]).

describe_text(listing,[
'listing : A -> o	listing <predicate-name>.',
'	Print out the clauses on the current file for the given',
'	predicate name. '
]).

describe_text(write_module,[
'write_module : A -> o	write_module <module>.',
'	Write the module out to the current file.'
]).

describe_text(write,[
'write : A -> o		write <term>.',
'	Print the term on the current file.'
]).

describe_text(writesans,[
'writesans : string -> o	writesans <string>.',
'	Print a string without quotes.'
]).

describe_text(nl,[
'nl : o			nl.',
'	Print a new line.'
]).

describe_text(tell,[
'tell : A -> o		tell <filename>.',
'	The same as in C-Prolog.  Make the file current for output. '
]).

describe_text(told,[
'told : o		told.',
'	The same as in C-Prolog.  Close the output file.'
]).

describe_text(read,[
'read : A -> o		read <term>.',
'	Read in a term from the current input file and unify it with',
'	the given term.'
]).

describe_text(see,[
'see : A -> o		see <filename>.',
'	The same as in C-Prolog.  Make the file current for input.'
]).

describe_text(seen,[
'seen : A		seen.',
'	The same as in C-Prolog.  Close the current input file.'
]).

describe_text(halt,[
'halt : o		halt.',
'	Leaves both lp and C-Prolog.'
]).

describe_text(bye,[
'bye : o		bye.',
'	A variation on halt; leaves both lp and C-Prolog.'
]).

describe_text(stop,[
'stop : o		stop.',
'	Leave lp and enter C-Prolog.'
]).

describe_text(break,[
'break : o		break.',
'	Recursively call C-Prolog.  Return to lambda Prolog with ^D.',
'	Once in C-Prolog, you can call lambda Prolog again.  There is',
'	no way, however, to leave lambda Prolog without calling an abort.', 
'	The abort will throw away the recursive calls.'
]).

describe_text(trace,[
'trace : opt -> o	trace <trace-option>',
'	For specifying a trace option.  The legal options are:',
'	clause, goal, interp, unifier, allopts.'
]).

describe_text(untrace,[
'untrace : opt -> o	untrace <trace-option>',
'	Selectively turn off a trace option. allopts is the catch-all.'
]).

describe_text(statistics,[
'statistics : o		statistics.',
'	The same as in C-Prolog.  Print some statistics about',
'	C-Prolog. '
]).

describe_text(switch,[
'switch : Opt -> Val -> o		switch option value.',
'  This may be used for changing the default settings for switches.',
'  Currently the following options and values are implemented:',
'         printtypes --> on/off     [Default: off]',
'     Determines whether types are to be printed with terms.',
'         freezetypes --> on/off    [Default: off]',
'     Determines whether types variables are to be frozen in goals.',
'         tvw --> on/off            [Default: on]',
'     Determines whether warning is to be printed when type variables',
'     need to be instantiated in unification',
'         projfirst --> on/off      [Default: off]',
'     Determines whether projection is to be attempted first in unification.',
' '
]).

describe_text(internal,[
'internal : A -> o	internal <term>.',
'	Print the internal representation of <term>.'
]).

describe_text(system,[
'system : string -> o	system <string>.',
'	Passes the string to the C-Prolog system predicate.
        This is the way to access the operating system.'
]).

describe_text(recon,[
'recon : A -> o		recon <C-Prolog-file>.',
'	Reconsult a C-Prolog file.  The extension ".pro" will be added.'
]).

describe_text(clean_ff,[
'clean_ff : o		clean_ff.',
'	Simplify the current flex-flex constraints by removing',
'	some vacuous abstractions and by pruning arguments from',
'	some free variables.'
]).

describe_text(definition,[
'definition : A -> o -> o	definition <pred-name> <formula>.',
'	Take the predicate name in the first argument, construct the',
'	conjunction of the universal forms of the Horn clauses with that ',
'	predicate as its head and then unify it with the second',
'	arguement.  This only works if the clauses do not have any',
'	type variables in them.'
]).

describe_text(!,[
'! : o			!.',
'	This is CUT. '
]).

